Index: /branches/2018/dev_r8864_nemo_v3_6_ZTILDE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90
===================================================================
--- /branches/2018/dev_r8864_nemo_v3_6_ZTILDE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 9352)
+++ /branches/2018/dev_r8864_nemo_v3_6_ZTILDE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 9353)
@@ -718,17 +1192,74 @@
          CALL lbc_lnk( pe3_out(:,:,:), 'U', 1._wp )
          pe3_out(:,:,:) = pe3_out(:,:,:) + e3u_0(:,:,:)
+         ! 
+         IF ( (nmet==1).OR.(nmet==2) ) CALL wrk_dealloc( jpi, jpj, zs )
+         IF ( (nmet==1).OR.(nmet==2) ) CALL wrk_dealloc( jpi, jpj, jpk, zw )
+         !
          !               ! ------------------------------------- !
       CASE( 'V' )        ! interpolation from T-point to V-point !
          !               ! ------------------------------------- !
          ! horizontal surface weighted interpolation
-         DO jk = 1, jpk
+         IF (nmet==0) THEN
+            DO jk = 1, jpk
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1   ! vector opt.
+                     pe3_out(ji,jj,jk) = 0.5_wp * vmask(ji,jj,jk) * r1_e12v(ji,jj)                                   &
+                        &                       * (   e12t(ji,jj  ) * ( pe3_in(ji,jj  ,jk) - e3t_0(ji,jj  ,jk) )     &
+                        &                           + e12t(ji,jj+1) * ( pe3_in(ji,jj+1,jk) - e3t_0(ji,jj+1,jk) ) )
+                  END DO
+               END DO
+            END DO
+         ENDIF
+         !
+         IF ( (nmet==1).OR.(nmet==2) ) THEN
             DO jj = 1, jpjm1
                DO ji = 1, fs_jpim1   ! vector opt.
-                  pe3_out(ji,jj,jk) = 0.5_wp * vmask(ji,jj,jk) * r1_e12v(ji,jj)                                   &
-                     &                       * (   e12t(ji,jj  ) * ( pe3_in(ji,jj  ,jk) - e3t_0(ji,jj  ,jk) )     &
-                     &                           + e12t(ji,jj+1) * ( pe3_in(ji,jj+1,jk) - e3t_0(ji,jj+1,jk) ) )
-               END DO
-            END DO
-         END DO
+                  ! Correction at last level:
+                  jkbot = mbkv(ji,jj)
+                  pe3_out(ji,jj,jkbot) = -0.5_wp * vmask(ji,jj,jkbot) * r1_e12v(ji,jj) &
+                        &                    * (   e12t(ji,jj  ) * zw(ji,jj  ,jkbot)   &
+                        &                        + e12t(ji,jj+1) * zw(ji,jj+1,jkbot)   )
+                  !
+                  ! If there is a step, taper bottom interface:
+                  IF (hv_0(ji,jj) < 0.5_wp * ( ht_0(ji,jj) + ht_0(ji,jj+1) ) ) THEN
+                     IF ( ht_0(ji,jj+1) < ht_0(ji,jj) ) THEN
+!                        zmin = ztap * pe3_in(ji,jj+1,jkbot)
+                        zmin = ztap * (-zw(ji,jj+1,jkbot)+e3t_0(ji,jj+1,jkbot))
+                     ELSE
+!                        zmin = ztap * pe3_in(ji,jj  ,jkbot)
+                        zmin = ztap * (-zw(ji,jj,jkbot)+e3t_0(ji,jj,jkbot))
+                     ENDIF
+                     zmin = -e3v_0(ji,jj,jkbot) + zmin
+                     pe3_out(ji,jj,jkbot) = MAX(pe3_out(ji,jj,jkbot), zmin)
+                  ENDIF
+                  !
+                  zdo =  -pe3_out(ji,jj,jkbot)
+                  DO jk=jkbot-1,1,-1
+                     zup = 0.5_wp * vmask(ji,jj,jk) * r1_e12v(ji,jj  ) &
+                              &                     *  ( e12t(ji,jj  ) * zw(ji,jj  ,jk) &
+                              &                         +e12t(ji,jj+1) * zw(ji,jj+1,jk) )
+                     !
+                     pe3_out(ji,jj,jk) = zdo - zup 
+                     zdo =  zdo - pe3_out(ji,jj,jk)
+                  END DO
+               END DO
+            END DO
+         END IF
+         ! 
+         IF (nmet==2) THEN           ! Spread sea level anomaly
+            !
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  DO jk=1,jpk
+                     pe3_out(ji,jj,jk) =       pe3_out(ji,jj,jk)                                 &
+                           &               + ( pe3_out(ji,jj,jk) + e3v_0(ji,jj,jk) )             & 
+                           &               / ( hv_0(ji,jj) + 1._wp - vmask_i(ji,jj) )            &
+                           &               * 0.5_wp * vmask(ji,jj,jk) * r1_e12v(ji,jj)           &
+                           &               * ( e12t(ji,jj)*zs(ji,jj) + e12t(ji,jj+1)*zs(ji,jj+1) )       
+                  END DO
+               END DO
+            END DO
+            !
+         ENDIF
          !
          IF( l_is_orca ) CALL dom_vvl_orca_fix( pe3_in, pe3_out, pout )
@@ -736,17 +1267,91 @@
          CALL lbc_lnk( pe3_out(:,:,:), 'V', 1._wp )
          pe3_out(:,:,:) = pe3_out(:,:,:) + e3v_0(:,:,:)
+         ! 
+         IF ( (nmet==1).OR.(nmet==2) ) CALL wrk_dealloc( jpi, jpj, zs )
+         IF ( (nmet==1).OR.(nmet==2) ) CALL wrk_dealloc( jpi, jpj, jpk, zw )
+         !
          !               ! ------------------------------------- !
-      CASE( 'F' )        ! interpolation from U-point to F-point !
+      CASE( 'F' )        ! interpolation from T-point to F-point !
          !               ! ------------------------------------- !
          ! horizontal surface weighted interpolation
-         DO jk = 1, jpk
+         IF (nmet==0) THEN
+            DO jk=1,jpk
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1   ! vector opt.
+                     pe3_out(ji,jj,jk) = 0.25_wp * umask(ji,jj,jk) * umask(ji,jj+1,jk) * r1_e12f(ji,jj) &
+                           &      * (  e12t(ji  ,jj  ) * ( pe3_in(ji  ,jj  ,jk)-e3t_0(ji  ,jj  ,jk) )   & 
+                           &         + e12t(ji  ,jj+1) * ( pe3_in(ji  ,jj+1,jk)-e3t_0(ji  ,jj+1,jk) )   &
+                           &         + e12t(ji+1,jj  ) * ( pe3_in(ji+1,jj  ,jk)-e3t_0(ji+1,jj  ,jk) )   & 
+                           &         + e12t(ji+1,jj+1) * ( pe3_in(ji+1,jj+1,jk)-e3t_0(ji+1,jj+1,jk) ))                                                      
+                  END DO
+               END DO
+            END DO 
+         ENDIF
+         !
+         IF ( (nmet==1).OR.(nmet==2) ) THEN
             DO jj = 1, jpjm1
                DO ji = 1, fs_jpim1   ! vector opt.
-                  pe3_out(ji,jj,jk) = 0.5_wp * umask(ji,jj,jk) * umask(ji,jj+1,jk) * r1_e12f(ji,jj)               &
-                     &                       * (   e12u(ji,jj  ) * ( pe3_in(ji,jj  ,jk) - e3u_0(ji,jj  ,jk) )     &
-                     &                           + e12u(ji,jj+1) * ( pe3_in(ji,jj+1,jk) - e3u_0(ji,jj+1,jk) ) )
-               END DO
-            END DO
-         END DO
+                  ! bottom correction:
+                  jkbot = MIN(mbku(ji,jj), mbku(ji,jj+1)) 
+                  pe3_out(ji,jj,jkbot) = -0.25_wp * umask(ji,jj,jkbot) * umask(ji,jj+1,jkbot) * r1_e12f(ji,jj) &
+                        &                         * (  e12t(ji  ,jj  ) * zw(ji  ,jj  ,jkbot)   &
+                        &                            + e12t(ji+1,jj  ) * zw(ji+1,jj  ,jkbot)   &
+                        &                            + e12t(ji  ,jj+1) * zw(ji  ,jj+1,jkbot)   &
+                        &                            + e12t(ji+1,jj+1) * zw(ji+1,jj+1,jkbot)   )
+                  !
+                  ! If there is a step, taper bottom interface:
+                  IF (hf_0(ji,jj) < 0.5_wp * ( hu_0(ji,jj  ) + hu_0(ji,jj+1) ) ) THEN
+                     IF ( hu_0(ji,jj+1) < hu_0(ji,jj) ) THEN
+                        IF ( ht_0(ji+1,jj+1) < ht_0(ji  ,jj+1) ) THEN
+!                           zmin = ztap * pe3_in(ji+1,jj+1,jkbot)
+                           zmin = ztap * (-zw(ji+1,jj+1,jkbot)+e3t_0(ji+1,jj+1,jkbot))
+                        ELSE
+!                           zmin = ztap * pe3_in(ji  ,jj+1,jkbot)
+                           zmin = ztap * (-zw(ji,jj+1,jkbot)+e3t_0(ji,jj+1,jkbot))
+                        ENDIF
+                     ELSE
+                        IF ( ht_0(ji+1,jj  ) < ht_0(ji  ,jj  ) ) THEN
+!                           zmin = ztap * pe3_in(ji+1,jj  ,jkbot)
+                           zmin = ztap * (-zw(ji+1,jj,jkbot)+e3t_0(ji+1,jj,jkbot))
+                        ELSE
+!                           zmin = ztap * pe3_in(ji  ,jj  ,jkbot)
+                           zmin = ztap * (-zw(ji,jj,jkbot)+e3t_0(ji,jj,jkbot))
+                        ENDIF
+                     ENDIF
+                     zmin = -e3f_0(ji,jj,jkbot) + zmin
+                     pe3_out(ji,jj,jkbot) = MAX(pe3_out(ji,jj,jkbot), zmin)
+                  ENDIF
+                  !
+                  zdo =  -pe3_out(ji,jj,jkbot)
+                  DO jk=jkbot-1,1,-1
+                     zup =  0.25_wp * umask(ji,jj,jk) * umask(ji,jj+1,jk) * r1_e12f(ji,jj) &
+                           &        * (  e12t(ji  ,jj  ) * zw(ji  ,jj  ,jk)  & 
+                           &           + e12t(ji+1,jj  ) * zw(ji+1,jj  ,jk)  & 
+                           &           + e12t(ji  ,jj+1) * zw(ji  ,jj+1,jk)  & 
+                           &           + e12t(ji+1,jj+1) * zw(ji+1,jj+1,jk)  )
+                     pe3_out(ji,jj,jk) = zdo - zup 
+                     !
+                     zdo =  zdo - pe3_out(ji,jj,jk)                                    
+                  END DO
+                  !
+               END DO
+            END DO 
+         ENDIF
+         !
+         IF (nmet==2) THEN           ! Spread sea level anomaly
+            !
+            DO jj = 1, jpjm1
+               DO ji = 1, fs_jpim1   ! vector opt.
+                  DO jk=1,jpk
+                     pe3_out(ji,jj,jk) =       pe3_out(ji,jj,jk)                                         &
+                           &               + ( pe3_out(ji,jj,jk) + e3f_0(ji,jj,jk) )                     & 
+                           &               / ( hf_0(ji,jj) + 1._wp - umask_i(ji,jj)*umask_i(ji,jj+1) )   &
+                           &               * 0.25_wp * umask(ji,jj,jk)*umask(ji,jj+1,jk)*r1_e12f(ji,jj)  &
+                           &               * ( e12t(ji  ,jj)*zs(ji  ,jj) + e12t(ji  ,jj+1)*zs(ji  ,jj+1) &
+                           &                  +e12t(ji+1,jj)*zs(ji+1,jj) + e12t(ji+1,jj+1)*zs(ji+1,jj+1) )               
+                  END DO
+               END DO
+            END DO
+         END IF
          !
          IF( l_is_orca ) CALL dom_vvl_orca_fix( pe3_in, pe3_out, pout )
@@ -754,4 +1359,8 @@
          CALL lbc_lnk( pe3_out(:,:,:), 'F', 1._wp )
          pe3_out(:,:,:) = pe3_out(:,:,:) + e3f_0(:,:,:)
+         ! 
+         IF ( (nmet==1).OR.(nmet==2) ) CALL wrk_dealloc( jpi, jpj, zs )
+         IF ( (nmet==1).OR.(nmet==2) ) CALL wrk_dealloc( jpi, jpj, jpk, zw )
+         !
          !               ! ------------------------------------- !
       CASE( 'W' )        ! interpolation from T-point to W-point !
@@ -808,5 +1417,6 @@
       !! * Local declarations
       INTEGER ::   jk
-      INTEGER ::   id1, id2, id3, id4, id5     ! local integers
+      INTEGER, DIMENSION(7) ::   id            ! local integers
+      REAL(wp), POINTER, DIMENSION(:,:) :: zhdiv
       !!----------------------------------------------------------------------
       !
@@ -818,13 +1428,16 @@
             CALL iom_get( numror, jpdom_autoglo, 'sshn'   , sshn    )
             !
-            id1 = iom_varid( numror, 'fse3t_b', ldstop = .FALSE. )
-            id2 = iom_varid( numror, 'fse3t_n', ldstop = .FALSE. )
-            id3 = iom_varid( numror, 'tilde_e3t_b', ldstop = .FALSE. )
-            id4 = iom_varid( numror, 'tilde_e3t_n', ldstop = .FALSE. )
-            id5 = iom_varid( numror, 'hdiv_lf', ldstop = .FALSE. )
+            id(1) = iom_varid( numror, 'fse3t_b', ldstop = .FALSE. )
+            id(2) = iom_varid( numror, 'fse3t_n', ldstop = .FALSE. )
+            id(3) = iom_varid( numror, 'tilde_e3t_b', ldstop = .FALSE. )
+            id(4) = iom_varid( numror, 'tilde_e3t_n', ldstop = .FALSE. )
+            id(5) = iom_varid( numror, 'hdivn_lf', ldstop = .FALSE. )
+            id(6) = iom_varid( numror, 'un_lf'   , ldstop = .FALSE. )
+            id(7) = iom_varid( numror, 'vn_lf'   , ldstop = .FALSE. )
+
             !                             ! --------- !
             !                             ! all cases !
             !                             ! --------- !
-            IF( MIN( id1, id2 ) > 0 ) THEN       ! all required arrays exist
+            IF( MIN( id(1), id(2) ) > 0 ) THEN       ! all required arrays exist
                CALL iom_get( numror, jpdom_autoglo, 'fse3t_b', fse3t_b(:,:,:) )
                CALL iom_get( numror, jpdom_autoglo, 'fse3t_n', fse3t_n(:,:,:) )
@@ -838,12 +1451,12 @@
                   fse3t_b(:,:,:) = fse3t_n(:,:,:)
                ENDIF
-            ELSE IF( id1 > 0 ) THEN
+            ELSE IF( id(1) > 0 ) THEN
                IF(lwp) write(numout,*) 'dom_vvl_rst WARNING : fse3t_n not found in restart files'
                IF(lwp) write(numout,*) 'fse3t_n set equal to fse3t_b.'
                IF(lwp) write(numout,*) 'neuler is forced to 0'
                CALL iom_get( numror, jpdom_autoglo, 'fse3t_b', fse3t_b(:,:,:) )
-               fse3t_n(:,:,:) = fse3t_b(:,:,:)
+               fse3t_b(:,:,:) = fse3t_n(:,:,:)
                neuler = 0
-            ELSE IF( id2 > 0 ) THEN
+            ELSE IF( id(2) > 0 ) THEN
                IF(lwp) write(numout,*) 'dom_vvl_rst WARNING : fse3t_b not found in restart files'
                IF(lwp) write(numout,*) 'fse3t_b set equal to fse3t_n.'
@@ -867,5 +1480,5 @@
             IF( ln_vvl_zstar ) THEN       ! z_star case !
                !                          ! ----------- !
-               IF( MIN( id3, id4 ) > 0 ) THEN
+               IF( MIN( id(3), id(4) ) > 0 ) THEN
                   CALL ctl_stop( 'dom_vvl_rst: z_star cannot restart from a z_tilde or layer run' )
                ENDIF
@@ -873,5 +1486,5 @@
             ELSE                          ! z_tilde and layer cases !
                !                          ! ----------------------- !
-               IF( MIN( id3, id4 ) > 0 ) THEN  ! all required arrays exist
+               IF( MIN( id(3), id(4) ) > 0 ) THEN  ! all required arrays exist
                   CALL iom_get( numror, jpdom_autoglo, 'tilde_e3t_b', tilde_e3t_b(:,:,:) )
                   CALL iom_get( numror, jpdom_autoglo, 'tilde_e3t_n', tilde_e3t_n(:,:,:) )
@@ -879,14 +1492,21 @@
                   tilde_e3t_b(:,:,:) = 0.0_wp
                   tilde_e3t_n(:,:,:) = 0.0_wp
-               ENDIF
-               !                          ! ------------ !
+                  !
+                  neuler = 0
+               ENDIF                      ! ------------ !
                IF( ln_vvl_ztilde ) THEN   ! z_tilde case !
                   !                       ! ------------ !
-                  IF( id5 > 0 ) THEN  ! required array exists
-                     CALL iom_get( numror, jpdom_autoglo, 'hdiv_lf', hdiv_lf(:,:,:) )
-                  ELSE                ! array is missing
-                     hdiv_lf(:,:,:) = 0.0_wp
+                  IF( MINVAL(id(5:7) ) > 0 ) THEN  ! all required arrays exist
+                     CALL iom_get( numror, jpdom_autoglo, 'hdivn_lf', hdivn_lf(:,:,:) )
+                     CALL iom_get( numror, jpdom_autoglo, 'un_lf'   ,    un_lf(:,:,:) )
+                     CALL iom_get( numror, jpdom_autoglo, 'vn_lf'   ,    vn_lf(:,:,:) )
+                  ELSE                            ! one at least array is missing
+                     hdivn_lf(:,:,:) = 0.0_wp
+                     un_lf(:,:,:)    = 0.0_wp
+                     vn_lf(:,:,:)    = 0.0_wp
+                     neuler = 0
                   ENDIF
                ENDIF
+               !
             ENDIF
             !
@@ -898,6 +1518,10 @@
                tilde_e3t_b(:,:,:) = 0.0_wp
                tilde_e3t_n(:,:,:) = 0.0_wp
-               IF( ln_vvl_ztilde ) hdiv_lf(:,:,:) = 0.0_wp
             END IF
+            IF( ln_vvl_ztilde ) THEN
+               hdivn_lf(:,:,:) = 0.0_wp
+               un_lf(:,:,:)    = 0.0_wp
+               vn_lf(:,:,:)    = 0.0_wp
+            ENDIF
          ENDIF
 
@@ -919,5 +1543,7 @@
          IF( ln_vvl_ztilde ) THEN                    ! z_tilde case !
             !                                        ! ------------ !
-            CALL iom_rstput( kt, nitrst, numrow, 'hdiv_lf', hdiv_lf(:,:,:) )
+            CALL iom_rstput( kt, nitrst, numrow, 'hdivn_lf', hdivn_lf(:,:,:) )
+            CALL iom_rstput( kt, nitrst, numrow, 'un_lf'   , un_lf(:,:,:)    )
+            CALL iom_rstput( kt, nitrst, numrow, 'vn_lf'   , vn_lf(:,:,:)    )
          ENDIF
 
@@ -926,5 +1552,4 @@
 
    END SUBROUTINE dom_vvl_rst
-
 
    SUBROUTINE dom_vvl_ctl
@@ -938,7 +1563,13 @@
       INTEGER ::   ios
 
-      NAMELIST/nam_vvl/ ln_vvl_zstar, ln_vvl_ztilde, ln_vvl_layer, ln_vvl_ztilde_as_zstar, &
-                      & ln_vvl_zstar_at_eqtor      , rn_ahe3     , rn_rst_e3t            , &
-                      & rn_lf_cutoff               , rn_zdef_max , ln_vvl_dbg                ! not yet implemented: ln_vvl_kepe
+      NAMELIST/nam_vvl/ ln_vvl_zstar               , ln_vvl_ztilde                       , &
+                      & ln_vvl_layer               , ln_vvl_ztilde_as_zstar              , &
+                      & ln_vvl_zstar_at_eqtor      , ln_vvl_zstar_on_shelf               , &
+                      & ln_vvl_adv_cn2             , ln_vvl_adv_fct                      , &
+                      & ln_vvl_lap                 , ln_vvl_blp                          , &
+                      & rn_ahe3_lap                , rn_ahe3_blp                         , &
+                      & rn_rst_e3t                 , rn_lf_cutoff                        , &
+                      & ln_vvl_regrid              , rn_zdef_max                         , &
+                      & ln_vvl_dbg   ! not yet implemented: ln_vvl_kepe
       !!---------------------------------------------------------------------- 
 
@@ -961,9 +1592,18 @@
          WRITE(numout,*) '              layer                      ln_vvl_layer   = ', ln_vvl_layer
          WRITE(numout,*) '              ztilde as zstar   ln_vvl_ztilde_as_zstar  = ', ln_vvl_ztilde_as_zstar
-         WRITE(numout,*) '      ztilde near the equator    ln_vvl_zstar_at_eqtor  = ', ln_vvl_zstar_at_eqtor
          ! WRITE(numout,*) '           Namelist nam_vvl : chose kinetic-to-potential energy conservation'
          ! WRITE(numout,*) '                                         ln_vvl_kepe    = ', ln_vvl_kepe
-         WRITE(numout,*) '           Namelist nam_vvl : thickness diffusion coefficient'
-         WRITE(numout,*) '                                         rn_ahe3        = ', rn_ahe3
+         WRITE(numout,*) '      ztilde near the equator    ln_vvl_zstar_at_eqtor  = ', ln_vvl_zstar_at_eqtor
+         WRITE(numout,*) '      ztilde on shelves          ln_vvl_zstar_on_shelf  = ', ln_vvl_zstar_on_shelf
+         WRITE(numout,*) '           Namelist nam_vvl : thickness advection scheme'
+         WRITE(numout,*) '              2nd order                  ln_vvl_adv_cn2 = ', ln_vvl_adv_cn2
+         WRITE(numout,*) '              2nd order FCT              ln_vvl_adv_fct = ', ln_vvl_adv_fct                    
+         WRITE(numout,*) '           Namelist nam_vvl : thickness diffusion scheme'
+         WRITE(numout,*) '              Laplacian                  ln_vvl_lap     = ', ln_vvl_lap
+         WRITE(numout,*) '              Bilaplacian                ln_vvl_blp     = ', ln_vvl_blp
+         WRITE(numout,*) '              Laplacian   coefficient    rn_ahe3_lap    = ', rn_ahe3_lap
+         WRITE(numout,*) '              Bilaplacian coefficient    rn_ahe3_blp    = ', rn_ahe3_blp
+         WRITE(numout,*) '           Namelist nam_vvl : layers regriding'
+         WRITE(numout,*) '              ln_vvl_regrid                              = ', ln_vvl_regrid
          WRITE(numout,*) '           Namelist nam_vvl : maximum e3t deformation fractional change'
          WRITE(numout,*) '                                         rn_zdef_max    = ', rn_zdef_max
@@ -992,5 +1632,11 @@
 
       IF( ioptio /= 1 )   CALL ctl_stop( 'Choose ONE vertical coordinate in namelist nam_vvl' )
-      IF( .NOT. ln_vvl_zstar .AND. nn_isf .NE. 0) CALL ctl_stop( 'Only vvl_zstar has been tested with ice shelf cavity' )
+
+      IF ( ln_vvl_ztilde.OR.ln_vvl_layer ) THEN 
+         ioptio = 0                      ! Choose one advection scheme at most
+         IF( ln_vvl_adv_cn2         )        ioptio = ioptio + 1
+         IF( ln_vvl_adv_fct         )        ioptio = ioptio + 1
+         IF( ioptio /= 1 )   CALL ctl_stop( 'Choose ONE thickness advection scheme in namelist nam_vvl' )
+      ENDIF
 
       IF(lwp) THEN                   ! Print the choice
